function [OUTIMG,AvRows,AvRows_sm]=filtering_stripes_CRC;

% Filtering banding noise by substruction of difference between average
% along bands and its smoothed copy
% 2 modes of smoothing: local mean and local median in window of SmWSz
% samples (odd number)
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Usage OUTIMG=filtering_stripes_CRC;)

figure_n(4);
load StripeNoiseImg;
INPIMG=StripeNoiseImg;
figure(1);
imshow(INPIMG,[]);
title('Input image','FontWeight','Bold');
[SzX,SzY]=size(INPIMG);

s=1;
while s==1,
    
    SmWSz=inputdlg('Enter size of the smothing window (odd number)');
    SmWSz=str2double(SmWSz);
    Lext=(SmWSz-1)/2;
    AvRows=mean(INPIMG,2);
    AvRows_sm=AvRows;
    m=menu('Smoothing by means of','LocMean','LocMedian');
    AvRows_ext=[flipud(AvRows(1:Lext));AvRows;flipud(AvRows(SzX-Lext+1:SzX))];
    switch m;
        case 1,AvRows_sm=conv2(AvRows_ext,ones(SmWSz,1)/SmWSz,'valid');
        case 2,
            for x=1:SzX,
                AvRows_sm(x)=median(AvRows_ext(x:x+SmWSz-1));
            end
    end
    figure(2)
    plot(1:SzX,AvRows,'r',1:SzX,AvRows_sm,'b','LineWidth',2);
    xlabel('Row index','FontWeight','Bold')
    axis tight
    title(['Size of the smoothing window =',num2str(SmWSz)],'FontWeight','Bold');
    grid on
    legend('Av. image rows','Smoothed Av. image rows')
    set(gca,'FontWeight','Bold');
    Correction=kron(AvRows-AvRows_sm,ones(1,SzY));
    OUTIMG=INPIMG-Correction;
    figure(3);
    imshow(OUTIMG,[])
    title('Corrected image','FontWeight','Bold')
    figure(4)
    imshow(Correction,[]);
    title('Noise removed','FontWeight','Bold')
    s=menu('Another window size?','Yes','No');
end



